git-rebase.shon commit Merge branch 'maint' (5071877)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .dotest working files, use the command
  18git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.  You must be in the top
  22directory of your project to start (or continue) a rebase.
  23
  24Example:       git-rebase master~1 topic
  25
  26        A---B---C topic                   A'\''--B'\''--C'\'' topic
  27       /                   -->           /
  28  D---E---F---G master          D---E---F---G master
  29'
  30
  31SUBDIRECTORY_OK=Yes
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest=$GIT_DIR/.dotest-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget to use git add?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        if ! git diff-index --quiet HEAD
  63        then
  64                if ! git-commit -C "`cat $dotest/current`"
  65                then
  66                        echo "Commit failed, please do not call \"git commit\""
  67                        echo "directly, but instead do one of the following: "
  68                        die "$RESOLVEMSG"
  69                fi
  70                printf "Committed: %0${prec}d" $msgnum
  71        else
  72                printf "Already applied: %0${prec}d" $msgnum
  73        fi
  74        echo ' '`git rev-list --pretty=oneline -1 HEAD | \
  75                                sed 's/^[a-f0-9]\+ //'`
  76
  77        prev_head=`git rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat $dotest/cmt.$1)"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git rev-parse --verify HEAD)
  90        cmt_name=$(git symbolic-ref HEAD)
  91        msgnum=$(cat $dotest/msgnum)
  92        end=$(cat $dotest/end)
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                git rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118finish_rb_merge () {
 119        rm -r "$dotest"
 120        echo "All done."
 121}
 122
 123is_interactive () {
 124        test -f "$dotest"/interactive ||
 125        while case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
 126        do
 127                shift
 128        done && test -n "$1"
 129}
 130
 131is_interactive "$@" && exec git-rebase--interactive "$@"
 132
 133while case "$#" in 0) break ;; esac
 134do
 135        case "$1" in
 136        --continue)
 137                git diff-files --quiet || {
 138                        echo "You must edit all merge conflicts and then"
 139                        echo "mark them as resolved using git add"
 140                        exit 1
 141                }
 142                if test -d "$dotest"
 143                then
 144                        prev_head="`cat $dotest/prev_head`"
 145                        end="`cat $dotest/end`"
 146                        msgnum="`cat $dotest/msgnum`"
 147                        onto="`cat $dotest/onto`"
 148                        continue_merge
 149                        while test "$msgnum" -le "$end"
 150                        do
 151                                call_merge "$msgnum"
 152                                continue_merge
 153                        done
 154                        finish_rb_merge
 155                        exit
 156                fi
 157                git am --resolved --3way --resolvemsg="$RESOLVEMSG"
 158                exit
 159                ;;
 160        --skip)
 161                if test -d "$dotest"
 162                then
 163                        git rerere clear
 164                        prev_head="`cat $dotest/prev_head`"
 165                        end="`cat $dotest/end`"
 166                        msgnum="`cat $dotest/msgnum`"
 167                        msgnum=$(($msgnum + 1))
 168                        onto="`cat $dotest/onto`"
 169                        while test "$msgnum" -le "$end"
 170                        do
 171                                call_merge "$msgnum"
 172                                continue_merge
 173                        done
 174                        finish_rb_merge
 175                        exit
 176                fi
 177                git am -3 --skip --resolvemsg="$RESOLVEMSG"
 178                exit
 179                ;;
 180        --abort)
 181                git rerere clear
 182                if test -d "$dotest"
 183                then
 184                        rm -r "$dotest"
 185                elif test -d .dotest
 186                then
 187                        rm -r .dotest
 188                else
 189                        die "No rebase in progress?"
 190                fi
 191                git reset --hard ORIG_HEAD
 192                exit
 193                ;;
 194        --onto)
 195                test 2 -le "$#" || usage
 196                newbase="$2"
 197                shift
 198                ;;
 199        -M|-m|--m|--me|--mer|--merg|--merge)
 200                do_merge=t
 201                ;;
 202        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 203                --strateg=*|--strategy=*|\
 204        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 205                case "$#,$1" in
 206                *,*=*)
 207                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 208                1,*)
 209                        usage ;;
 210                *)
 211                        strategy="$2"
 212                        shift ;;
 213                esac
 214                do_merge=t
 215                ;;
 216        -v|--verbose)
 217                verbose=t
 218                ;;
 219        -C*)
 220                git_am_opt=$1
 221                shift
 222                ;;
 223        -*)
 224                usage
 225                ;;
 226        *)
 227                break
 228                ;;
 229        esac
 230        shift
 231done
 232
 233# Make sure we do not have .dotest
 234if test -z "$do_merge"
 235then
 236        if mkdir .dotest
 237        then
 238                rmdir .dotest
 239        else
 240                echo >&2 '
 241It seems that I cannot create a .dotest directory, and I wonder if you
 242are in the middle of patch application or another rebase.  If that is not
 243the case, please rm -fr .dotest and run me again.  I am stopping in case
 244you still have something valuable there.'
 245                exit 1
 246        fi
 247else
 248        if test -d "$dotest"
 249        then
 250                die "previous dotest directory $dotest still exists." \
 251                        'try git-rebase < --continue | --abort >'
 252        fi
 253fi
 254
 255# The tree must be really really clean.
 256git update-index --refresh || exit
 257diff=$(git diff-index --cached --name-status -r HEAD)
 258case "$diff" in
 259?*)     echo "cannot rebase: your index is not up-to-date"
 260        echo "$diff"
 261        exit 1
 262        ;;
 263esac
 264
 265# The upstream head must be given.  Make sure it is valid.
 266upstream_name="$1"
 267upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 268    die "invalid upstream $upstream_name"
 269
 270# Make sure the branch to rebase onto is valid.
 271onto_name=${newbase-"$upstream_name"}
 272onto=$(git rev-parse --verify "${onto_name}^0") || exit
 273
 274# If a hook exists, give it a chance to interrupt
 275if test -x "$GIT_DIR/hooks/pre-rebase"
 276then
 277        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 278                echo >&2 "The pre-rebase hook refused to rebase."
 279                exit 1
 280        }
 281fi
 282
 283# If the branch to rebase is given, first switch to it.
 284case "$#" in
 2852)
 286        branch_name="$2"
 287        git-checkout "$2" || usage
 288        ;;
 289*)
 290        if branch_name=`git symbolic-ref -q HEAD`
 291        then
 292                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 293        else
 294                branch_name=HEAD ;# detached
 295        fi
 296        ;;
 297esac
 298branch=$(git rev-parse --verify "${branch_name}^0") || exit
 299
 300# Now we are rebasing commits $upstream..$branch on top of $onto
 301
 302# Check if we are already based on $onto with linear history,
 303# but this should be done only when upstream and onto are the same.
 304mb=$(git merge-base "$onto" "$branch")
 305if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 306        # linear history?
 307        ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
 308then
 309        echo >&2 "Current branch $branch_name is up to date."
 310        exit 0
 311fi
 312
 313if test -n "$verbose"
 314then
 315        echo "Changes from $mb to $onto:"
 316        # We want color (if set), but no pager
 317        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 318fi
 319
 320# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
 321echo "First, rewinding head to replay your work on top of it..."
 322git-reset --hard "$onto"
 323
 324# If the $onto is a proper descendant of the tip of the branch, then
 325# we just fast forwarded.
 326if test "$mb" = "$branch"
 327then
 328        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 329        exit 0
 330fi
 331
 332if test -z "$do_merge"
 333then
 334        git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
 335        git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
 336        exit $?
 337fi
 338
 339# start doing a rebase with git-merge
 340# this is rename-aware if the recursive (default) strategy is used
 341
 342mkdir -p "$dotest"
 343echo "$onto" > "$dotest/onto"
 344echo "$onto_name" > "$dotest/onto_name"
 345prev_head=`git rev-parse HEAD^0`
 346echo "$prev_head" > "$dotest/prev_head"
 347
 348msgnum=0
 349for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
 350do
 351        msgnum=$(($msgnum + 1))
 352        echo "$cmt" > "$dotest/cmt.$msgnum"
 353done
 354
 355echo 1 >"$dotest/msgnum"
 356echo $msgnum >"$dotest/end"
 357
 358end=$msgnum
 359msgnum=1
 360
 361while test "$msgnum" -le "$end"
 362do
 363        call_merge "$msgnum"
 364        continue_merge
 365done
 366
 367finish_rb_merge